# -*- coding: utf-8 -*-

GLADEFILE = "vee.glade"

import WIDGET, TAB, Dialog, child, i18n

_ = i18n.gettext()

def on_show_popup_TAB (obj, event, STATE) :

	if event.button == 3 :
		inTAB(event, state=STATE)

def on_show_popup_VTE (obj, event, STATE) :

	if event.button == 3 :
		inVTE(event, state=STATE)

class inVTE (WIDGET.WIDGET) :

	STATE = None
	NOTEBOOK = None
	LIST_TAB = list()
	CURRENT_PAGE = 0
	WIDGET = None

	def __init__ (self, event, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]
			self.NOTEBOOK = self.STATE.DATA["notebook"]
			self.LIST_TAB = self.STATE.DATA["tab-list"]
			self.CURRENT_PAGE = self.NOTEBOOK.get_current_page()

			self.WIDGET = self.LIST_TAB[self.CURRENT_PAGE].Child

		handler = { \
			"on_add_vim" : self.on_add_vim, \
			"on_add_terminal" : self.on_add_terminal, \
			"on_preferences" : self.on_preferences, \
			\
			"on_show_toolbar" : self.on_show_toolbar, \
			"on_show_menubar" : self.on_show_menubar, \

			"on_close_tab" : self.on_close_tab, \
		}

		WIDGET.WIDGET.__init__(self, "menu1", None)

		self.WIDGET_SELF.popup(None,None,None,event.button,event.time)

		# set the current state.
		for i in self.WIDGET_SELF.get_children() :
			if i.get_property("name") == "show_toolbar" :
				i.set_property( \
					"active", self.STATE.DATA["toolbar"].get_property("visible"))

			if i.get_property("name") == "show_menubar" :
				i.set_property( \
					"active", self.STATE.DATA["menubar"].get_property("visible"))

		self.xml.signal_autoconnect(handler)

		# attach gtk im menu
		#print self.WIDGET.CHILD_TYPE
		#if self.WIDGET.CHILD_TYPE in [child.TYPE_VIM, child.TYPE_TERMINAL] :
		#	print "callme"

	def on_close_tab (self, widget) :
		self.WIDGET.exit()

	def on_add_vim (self, widget) :
		pass

	def on_add_terminal (self, widget) :
		pass

	def on_preferences (self, widget) :
		Dialog.Preference()

	def on_show_toolbar (self, widget) :
		__toolbar = self.STATE.DATA["toolbar"]
		if __toolbar.get_property("visible") :
			__toolbar.hide()
		else :
			__toolbar.show()

	def on_show_menubar (self, widget) :
		__menubar = self.STATE.DATA["menubar"]
		if __menubar.get_property("visible") :
			__menubar.hide()
		else :
			__menubar.show()

class inTAB (WIDGET.WIDGET) :

	STATE = None

	def __init__ (self, event, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]

		handler = { \
			"on_show_toolbar" : self.on_show_toolbar, \
			"on_show_menubar" : self.on_show_menubar, \
			"on_preferences" : self.on_preferences, \
		}

		WIDGET.WIDGET.__init__(self, "menu2", None)

		self.WIDGET_SELF.popup(None,None,None,event.button,event.time)

		# set the current state.
		for i in self.WIDGET_SELF.get_children() :
			if i.get_property("name") == "show_toolbar" :
				i.set_property( \
					"active", self.STATE.DATA["toolbar"].get_property("visible"))

			if i.get_property("name") == "show_menubar" :
				i.set_property( \
					"active", self.STATE.DATA["menubar"].get_property("visible"))

		self.xml.signal_autoconnect(handler)

	def on_show_toolbar (self, widget) :
		__toolbar = self.STATE.DATA["toolbar"]
		if __toolbar.get_property("visible") :
			__toolbar.hide()
		else :
			__toolbar.show()

	def on_show_menubar (self, widget) :
		__menubar = self.STATE.DATA["menubar"]
		if __menubar.get_property("visible") :
			__menubar.hide()
		else :
			__menubar.show()

	def on_preferences (self, widget) :
		Dialog.Preference()

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Menu.py"


