#!/usr/bin/env python
# -*- coding: utf-8 -*-
import sys, os, shutil, sha, time

import pygtk
pygtk.require("2.0")

import i18n
_ = i18n.gettext()

try :
	import gtk
	import gtk.glade
	import gobject
	import pango
	import gconf
except :
	print _("You need to install pygtk or GTKv2.")
	sys.exit(1)

import Options, TAB, WIDGET, Label, State, \
	Dialog, GConf, Conf, Menu, child, func

class main (WIDGET.WIDGET) :

	LIST_TAB = list()
	NOTEBOOK = None

	STATE = None
	IS_LOGO = True

	Toolbar = None
	Menubar = None

	ARGS_OPTIONS = dict()
	ARGS_ARGS = list()

	ENTRY_EXTERNAL_COMMAND = None
	LISTSTORE_EXTERNAL_COMMAND = None

	LIST_TAB_SHORTCUT = dict()
	DIALOG_FILESELECTION = None

	def __init__ (self, **kwargs) :

		# parse arguments and options.
		if kwargs.has_key("args_options") :
			self.ARGS_OPTIONS = kwargs["args_options"]

		if kwargs.has_key("args_args") :
			self.ARGS_ARGS = kwargs["args_args"]

		handler = { \
			# etc.
			"on_font_select" : self.on_fontSelectionDialog, \
			"on_insert_vim" : self.on_insert_vim, \
			"on_insert_gvim" : self.on_insert_gvim, \
			"on_remove_page" : self.on_remove_page, \
			"on_open_file_dialog" : self.on_fileSelectionDialog, \
			"on_font_increase" : self.on_font_increase, \
			"on_font_decrease" : self.on_font_decrease, \
			"on_next_tab" : self.on_next_tab, \
			"on_previous_tab" : self.on_previous_tab, \
			"on_toggle_toolbar" : self.on_toggle_toolbar, \
			"on_toggle_menubar" : self.on_toggle_menubar, \
			"on_insert_terminal" : self.on_insert_terminal, \
			"on_external_command" : self.on_external_command, \
			"on_preference" : self.on_preference, \
			"on_about" : self.on_about, \
			"on_quit_all" : self.on_ready_to_quit, \
		}

		WIDGET.WIDGET.__init__(self, "vee", None, handler)

		self.WIDGET_SELF.set_title(_("vee"))

		# create accelerator group.
		self.AccelGrpGlobal = gtk.AccelGroup()
		self.AccelGrpWhenHideMenubar = gtk.AccelGroup()

		# register global keyboard shortcut.
		self.WIDGET_SELF.add_accel_group(self.AccelGrpGlobal)
		self.WIDGET_SELF.add_accel_group(self.AccelGrpWhenHideMenubar)

		self.__activate_accelerator( \
			self.AccelGrpGlobal, Conf.KEYBOARD_SHORTCUT_GLOBAL)
		self.__activate_accelerator( \
			self.AccelGrpWhenHideMenubar, \
			Conf.KEYBOARD_SHORTCUT_WHEN_HIDE_MENUBAR)

		self.STATE = State.State()

		# preference
		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		__callback_functions = {"addPage" : self.addPage}
		gconf_notify = GConf.Notify( \
			callback_functions=__callback_functions, \
			state=self.STATE \
		)

		gconf_notify.add()

		self.GCONF_CLIENT.set_path(Conf.LOCAL_ROOT)

		# window size matters.
		__wh = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["latest-window-geometry"]["key"])

		__wh0 = [ int(i) for i in __wh.split(",")]

		self.WIDGET_SELF.set_default_size(__wh0[0], __wh0[1])
		self.WIDGET_SELF.resize(__wh0[0], __wh0[1])
		#self.WIDGET_SELF.move(__wh0[2], __wh0[3])

		self.WIDGET_SELF.connect( \
			"size_request", self.on_window_shape_changed)

		self.NOTEBOOK = self.xml.get_widget("notebook1")
		self.NOTEBOOK.remove_page(0)
		self.NOTEBOOK.popup_disable()
		self.NOTEBOOK.connect( \
			"button-press-event", Menu.on_show_popup_TAB, self.STATE)

		# store information into state
		self.STATE.set_value("root-widget", self.WIDGET_SELF)
		self.STATE.set_value("notebook", self.NOTEBOOK)
		self.STATE.set_value("tab-list", self.LIST_TAB)

		# status bar.
		STATUSBAR = Label.Statusbar(self.xml.get_widget("statusbar1"))
		self.STATE.set_value("statusbar", STATUSBAR)

		# set event.
		EB = self.xml.get_widget("eventbox1")
		EB.connect("event", self.on_set_background_logo)

		# toolbar and menubar
		self.Toolbar = self.xml.get_widget("toolbar1")

		if not self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-toolbar"]["key"]) :
			self.Toolbar.hide()

		self.Menubar = self.xml.get_widget("hbox1")

		if not self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-menubar"]["key"]) :
			self.Menubar.hide()

		self.STATE.set_value("toolbar", self.Toolbar)
		self.STATE.set_value("menubar", self.Menubar)

		# external command entry.
		self.ENTRY_EXTERNAL_COMMAND = self.xml.get_widget("entry15")
		completion = gtk.EntryCompletion()
		self.ENTRY_EXTERNAL_COMMAND.set_completion(completion)
		self.LISTSTORE_EXTERNAL_COMMAND = gtk.ListStore(gobject.TYPE_STRING)
		completion.set_model(self.LISTSTORE_EXTERNAL_COMMAND)
		completion.set_text_column(0)

		print "==========================================="
		print _(" Launched.")
		print ""

		if len(self.ARGS_ARGS) > 0 :
			for i in self.ARGS_ARGS :
				self.addPage("vim", filename=i)
		else :
			if self.ARGS_OPTIONS.ARG_START_WITH_VIM : self.addPage("vim")
			if self.ARGS_OPTIONS.ARG_START_WITH_TERMINAL : self.addPage("terminal")

		if not self.ARGS_OPTIONS.ARG_SHOW_TOOLBAR : self.Toolbar.hide()
		if not self.ARGS_OPTIONS.ARG_SHOW_MENUBAR : self.Menubar.hide()

		###############################################################
		# ACTIVATE dnd.
		self.NOTEBOOK.connect( \
			"drag_data_received", self.on_drag_received)

		self.Menubar.connect( \
			"drag_data_received", self.on_drag_received)

		self.Toolbar.connect( \
			"drag_data_received", self.on_drag_received)

		self.NOTEBOOK.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		self.Menubar.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		self.Toolbar.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		#########################################################
		# settting for toolbutton.
		__button_gvim = self.xml.get_widget("toolbutton12")
		__button_vim = self.xml.get_widget("toolbutton1")
		__button_terminal = self.xml.get_widget("toolbutton8")
		__openfile_button = self.xml.get_widget("toolbutton5")
		__next_tab_button = self.xml.get_widget("toolbutton9")
		__perv_tab_button = self.xml.get_widget("toolbutton10")
		__command_label = self.xml.get_widget("label86")

		# connect signal for toolbutton.
		__button_vim.connect( \
			"drag_data_received", self.on_drag_received_button_vim)
		__button_vim.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		__button_gvim.connect( \
			"drag_data_received", self.on_drag_received_button_gvim)
		__button_gvim.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		__button_terminal.connect( \
			"drag_data_received", self.on_drag_received_button_terminal)
		__button_terminal.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		# whether gvim button set visible or not.
		__a = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["command-gvim"]["key"])

		self.STATE.set_value("gvim-button", __button_gvim)
		if len(__a) < 1 : __button_gvim.hide()

		# set label of toolbutton
		__button_gvim.set_label(_("GVIM"))
		__button_vim.set_label(_("VIM"))
		__openfile_button.set_label(_("Open File"))
		__button_terminal.set_label(_("Open Terminal"))
		__next_tab_button.set_label(_("Next Tab"))
		__perv_tab_button.set_label(_("Previous Tab"))
		__command_label.set_label(_("Command : "))

		# test ##################################################
		#self.addPage("gvim")
		#self.addExample()
		#Dialog.Preference()

	# EVENT HANDLER #####################################################
	def __addAccelKeySwitchTab (self) :
		"""
		그놈 터미널이나 에피파니처럼 Alt+숫자키로 탭이동하는 패치.
		 - 손경욱(vvs740@nospam@chol.com)님이 보내준 패치를 수정해서 적용
		"""

		__c = Conf.LIST_KEYBOARD_SHORTCUT["modifier-switch-tab"]

		num = len(self.LIST_TAB_SHORTCUT)
		__key, __mod = gtk.accelerator_parse(__c[0] % (num + 1))

		if self.LIST_TAB_SHORTCUT.has_key(__key) :
			return
		else :
			self.LIST_TAB_SHORTCUT[__key] = num
			self.AccelGrpGlobal.connect_group(__key, __mod, \
				gtk.ACCEL_VISIBLE, eval(__c[1]))

	def ac_change_nth_tab (self, parm1, parm2, parm3, parm4) :
		"""
		 - 손경욱(vvs740@nospam@chol.com)님이 보내준 패치를 수정해서 적용
		"""
		__n = self.LIST_TAB_SHORTCUT[parm3]
		self.NOTEBOOK.set_current_page(__n)

	def on_drag_received_button_vim \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("vim", filename=__path)

	def on_drag_received_button_gvim \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("gvim", filename=__path)

	def on_drag_received_button_terminal \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("terminal", directory=__path)

	def on_drag_received \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("vim", filename=__path)

	def on_ready_to_quit (self, parm1, parm2=None) :

		if type(self.IS_LOGO) is int :
			gtk.main_quit()
		else :
			Dialog.AskCloseAllTabDialog(self.WIDGET_SELF, self.STATE)

		return True

	def on_external_command (self, widget) :
		__c = widget.get_text()
		if len(__c.strip()) < 1 : return

		parsed_argv = func.parse_command_line_argument(__c)

		if len(parsed_argv["command"].strip()) < 1 : return

		if not func.is_valid_command(parsed_argv["command"]) :
			Dialog.NoValidCommand(parsed_argv["command"])
			return

		self.LISTSTORE_EXTERNAL_COMMAND.append([__c, ])

		#self.addPage("external_command", **parsed_argv)
		self.addPage("external_command", external_command=__c.strip())

	def on_window_shape_changed (self, widget, parm1) :

		__wh = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["latest-window-geometry"]["key"])
		__wh0 = [ int(i) for i in __wh.split(",")]

		(w, h) = self.WIDGET_SELF.get_size()

		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["latest-window-geometry"]["key"], \
			"%d,%d,%d,%d" % (w, h, __wh0[2], __wh0[3]) \
		)

	def on_toggle_menubar (self, widget) :
		if self.Menubar.get_property("visible") :
			self.Menubar.hide()
		else :
			self.Menubar.show()

	def on_toggle_toolbar (self, widget) :
		if self.Toolbar.get_property("visible") :
			self.Toolbar.hide()
		else :
			self.Toolbar.show()

	def on_set_background_logo (self, parm1, parm2) :

		if self.NOTEBOOK.get_n_pages() < 1 :
			self.addLogo()

	def on_fileSelectionDialog (self, widget) :
		if not self.DIALOG_FILESELECTION :
			self.DIALOG_FILESELECTION = Dialog.FileSelectionDialog(self)
		else :
			self.DIALOG_FILESELECTION.show()

	def on_fontSelectionDialog (self, widget) :
		Dialog.FontSelectionDialog( \
			self.xml, self.LIST_TAB[self.NOTEBOOK.get_current_page()])

	def on_preference (self, widget) :
		Dialog.Preference()

	def on_about (self, widget) :
		Dialog.About()

	def on_insert_gvim (self, widget) :
		self.addPage("gvim")

	def on_insert_vim (self, widget) :
		self.addPage("vim")

	def on_insert_terminal (self, widget) :
		self.addPage("terminal")

	def on_remove_page (self, widget) :
		current_page = self.NOTEBOOK.get_current_page()
		tab = self.LIST_TAB[current_page]
		tab.Child.exit()
		STATUSBAR.clean()

	def on_font_decrease (self, widget) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.decrease_font()

	def on_font_increase (self, widget) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.increase_font()

	def on_next_tab (self, widget) :
		self.NOTEBOOK.next_page()

	def on_previous_tab (self, widget) :
		self.NOTEBOOK.prev_page()

	def on_change_title (self, widget) :
		current_page = self.NOTEBOOK.get_current_page()

		__title = self.LIST_TAB[current_page].Child.get_title()

		self.set_title(__title)
		self.LIST_TAB[current_page].INSTANCE_LABEL.set_label(__title)

	def set_title (self, strings) :
		self.WIDGET_SELF.set_title(_("%s : VEE") % strings)

	#------------------------------------------------------------
	# Accel HANDLER
	def ac_font_decrease (self, parm1, parm2, parm3, parm4) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.decrease_font()

	def ac_font_increase (self, parm1, parm2, parm3, parm4) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.increase_font()

	def ac_insert_gvim (self, parm1, parm2, parm3, parm4) :
		self.addPage("gvim")

	def ac_insert_vim (self, parm1, parm2, parm3, parm4) :
		self.addPage("vim")

	def ac_insert_terminal (self, parm1, parm2, parm3, parm4) :
		self.addPage("terminal")

	def ac_fileSelectionDialog  (self, parm1, parm2, parm3, parm4) :
		if not self.DIALOG_FILESELECTION :
			self.DIALOG_FILESELECTION = Dialog.FileSelectionDialog(self)
		else :
			self.DIALOG_FILESELECTION.show()


	def ac_next_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.next_page()

	def ac_previous_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.prev_page()

	def ac_rotate_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.next_page()

	def ac_focus_on_external_command (self, parm1, parm2, parm3, parm4) :
		__entry = self.xml.get_widget("entry15")
		__entry.grab_focus()

	#############################################################
	# etc method.
	def __activate_accelerator (self, accel_group, shortcut_tuple=tuple()) :
		if len(shortcut_tuple) < 1 : return False

		for i in shortcut_tuple :
			__o = Conf.LIST_KEYBOARD_SHORTCUT[i]

			if len(__o) < 2 : continue

			__key, __mod = gtk.accelerator_parse(__o[0])
			accel_group.connect_group(__key, __mod, \
				gtk.ACCEL_VISIBLE, eval(__o[1]))

		return True

	def addLogo (self) :
		Logo = gtk.Image()
		Logo.set_from_file(os.path.join(Conf.DIR_PIXMAPS, "vee.png"))
		Logo.show()

		#self.NOTEBOOK.append_page(Logo)
		tab = TAB.TAB( \
			state=self.STATE, \
			without_closebutton=True)

		tab.addWidget(Logo, _("브이 VEE"))

		self.IS_LOGO = self.NOTEBOOK.get_current_page()
		self.STATE.set_value("is-logo", self.IS_LOGO)

	def addPage (self, childname, **kwargs) :
		if type(self.IS_LOGO) is int :
			self.NOTEBOOK.remove_page(self.IS_LOGO)
			self.IS_LOGO = False

		__tab = child.getTab(childname)
		tab = __tab(self.STATE, **kwargs)

		tab.make()

		self.__addAccelKeySwitchTab()

	def addExample (self) :

		if type(self.IS_LOGO) is int :
			self.NOTEBOOK.remove_page(self.IS_LOGO)
			self.IS_LOGO = False

		__example = child.getChild("example")
		example = __example()
		example.make()

		tab = TAB.TAB(state=self.STATE)
		tab.STR_TAB_NAME = _("Example")
		tab.addVTE(example)

		self.LIST_TAB.append(tab)

		# set window title
		#self.set_title(tab.INSTANCE_LABEL.get_label())

		example.WIDGET.connect("window-title-changed", self.on_change_title)

if __name__ == "__main__" :

	# parse command-line argument.
	__parser = Options.parseVEE()
	(__OPTIONS, __ARGS) = __parser.parse_args()

	# check whether the gconf schema was installed, if not install it.
	if __OPTIONS.ARG_INSTALL_SCHEMA :
		GConf.verify("install schema")
	else :
		GConf.verify()

	app = main(args_options=__OPTIONS, args_args=__ARGS)

	try :
		gtk.main()
	except :
		sys.exit(1)
	else :
		sys.exit(0)

